#include "Day3.hpp"

#include <algorithm>
#include <functional>
#include <numeric>
#include <string>

namespace Day3
{
Puzzle::Puzzle( std::string_view s, TraversalRule rule )
{
  init_lines( s );
  rules.push_back( rule );
}

Puzzle::Puzzle( std::string_view s,
                std::initializer_list< TraversalRule > rules ) :
  rules{ rules }
{
  init_lines( s );
}

void Puzzle::init_lines( std::string_view s )
{
  auto begin = std::cbegin( s );
  auto end = std::cend( s );
  auto predicate = []( char c ) { return c == '\n' || c == '\r'; };

  input_size = s.size() - static_cast< std::size_t >(
                            std::count_if( begin, end, predicate ) );

  auto it = begin;

  while( it != end )
  {
    it = std::find_if( begin, end, predicate );

    lines.emplace_back( begin, it );

    begin = it;

    if( it != end )
      begin++;
  }
}

std::size_t Puzzle::size() const
{
  return input_size;
}

char Puzzle::at( std::size_t x, std::size_t y ) const
{
  return lines[ y ][ x ];
}

bool Puzzle::isSharp( char c )
{
  return c == '#';
}

std::size_t Puzzle::width() const
{
  return lines.front().size();
}

std::size_t Puzzle::height_limit() const
{
  return lines.size() - 1;
}

std::size_t Puzzle::compute_result_for_rule( const TraversalRule &rule ) const
{
  std::size_t x{};
  std::size_t y{};
  std::size_t result{};

  if( isSharp( at( 0, 0 ) ) )
    result++;

  do
  {
    x += rule.right;
    y += rule.down;

    if( isSharp( at( x % width(), y ) ) )
      result++;
  } while( y < height_limit() );

  return result;
}

std::size_t Puzzle::traverse() const
{
  std::vector< std::size_t > results;
  results.reserve( rules.size() );

  for( auto &&rule : rules )
    results.push_back( compute_result_for_rule( rule ) );

  return std::reduce( std::cbegin( results ), std::cend( results ),
                      std::size_t{ 1 }, std::multiplies{} );
}

const char * const puzzle = R"_(.#......#..####.....#..#.......
#.#...#...#..#.#...#.#...##.##.
#.#....#..........#...##.....##
#.#.#.....##......#.#.......###
..#..###....#.#....#.#.#..#....
.......#.#....##..##...#...#...
..#..#..#..###.......#.....#.#.
.#.......#...##...##.##......##
#.#.##..##.#..#....#..###..#.#.
#.....#.#.........#.....##.#.#.
..#.#....##..#...#...##........
......#....#..##.#.#......###..
.......#.......#......##...#...
.##.....#.......#...###.....##.
.#...#.##..##.#..##....#.......
..#......##...#..#...#.#.##.###
.##.##.....##....#..#......#.#.
.#.....#..###..#.##.#.....##.#.
......##..........#..........#.
.##....#.....#..##.#..#.#..###.
..##.......#....#...##...#..#..
.##...#.....#.###.#.#..#...#.#.
.....##.#.##..##...#...........
..#..###.##.#.#.###...###..#.#.
.#........#..#.#........#.#...#
....##.......#....#.#.##.#.....
....##........######..###..#.#.
#.#.#............#.......#..#..
...##...#.##.....#.#..#......#.
......#.##.#....##..#.#..###...
##.....#.#....#....#.##.#.###..
#..#..#..##.#..##.##.##.#.##...
.###.####..#..#........#.....##
.......##..#.......#...........
.##...#............#.#.##...#..
....##.....#...##..#..#.#..###.
...#.....#####.#..#...##....##.
#.....#.#.#....##.......##.#.#.
......#.#..#.##.#######......#.
#.##...##....#..###.#.......#..
.....##...#....#...#....##.##.#
....###......#...###..#......##
..#...##..##.######..#.#......#
......##....#....##..#......##.
.#...#..##..#.###.#......#....#
##....##..#..####.#.....#...#..
.#.......#...#.......##......#.
......#...#...#........#.......
.#........#.###...#..####.#..#.
##...#.#............#.....###..
.....###.#.##...........###..#.
.#.#...#.....#.#.##..##...####.
..##.......#..#.##.#....#.....#
.#..#.#..####.....###.#.....#..
..#..###.....####..#.##.#.#.##.
.###..#.....#......#...####....
...#.#..#.#..#...#...#....##.##
..###....#.##.....#..........#.
###...#####......##............
..###.....#........##.#...#..#.
..##.##.#.....##........##..#.#
##..#.#...#.#..#..###.#....#..#
....#..#.#.....#..#####...#....
....#.........#......##.##.....
.#...####.##......##..##.#..#.#
...#...#.##..#...##..###...#...
###...#.....#.##.###.###..#.#..
..#......#.###.....#..##.#...#.
#.....##.########...#####....#.
........##..#..##..##.#........
....#.######....##..#..#.##..#.
#.......#..##..#..#.#.#..##.##.
...#.#..#..#.......#......###.#
.#.#..#.#..#.##.#.............#
#....#.##.#.#.....#..#.#..#....
...###..#...#....#.........#.#.
.#..#.....##..#.#..#.#.......#.
..#...##...#......#......####..
....#..#.......#.......#.#..#..
#...#..#...........#.#..#.....#
#...#.#.......#...#....###....#
.#..#.#.##....#......#........#
..#...#..##..#..#..#..#...#.#..
..#.#.........#....#....##.....
##.....##.#.#.#.........##.....
.##...#.##...........#...#...##
.##..##.#.#..........##..##....
#....#....#.#...#.#..#....#.#..
####....##.....#..##.###.......
#..#....#......##.#.#....#.....
.....#....#.###.##.........###.
#.......#.####..#..#..##.......
##.#.......#..##..#....#..#.#..
..###...#.#...#.....##.##.####.
....#...#.#....#..#..#.....#.##
#.....##.#.#..#.##..#..##......
................###..#....##...
..#.##.....#..........##.#...#.
..#.#..#.#....#.#.#..#..#..#.#.
#...#..##.#.#...#..#...#..#....
#..#.#.........#..###........#.
.#...#.............#..###..#..#
#.........#.#..#...#.#.....#..#
....#..#..#.#.#...#...#.....##.
##...###.#.####..#......#...#..
..#..##...#.#......#.#.......#.
#......###....##.#.##..........
#####....###..#...............#
##.#...####....#....#...#....#.
.#.......#..#.....#...#.....###
...#..#.#.#....##......##...#..
...#.....#...#.##.#..#.#....#..
#...###....#...#.#....#........
.#.......#........#...##.##.##.
.....#....#...##.....##...###.#
....#....#.#..#...##.##.##.....
.......#............#...#.#..#.
.#............#.....##.......#.
........#....#....##......##.##
.......##..#.#..#.##..###..##.#
#..##..##.........####.#.###...
#....#..#...##...#.............
#...#...###..........##..#..#..
....#...#..#.....##...#........
#.....#......#.#.....#...#..#..
..#.....#.....#....#..#........
..#..#.....#.#.........#..###..
................###..#.#....#..
#.....#.....#.#.#.#.#..#...#.#.
#....#....#.#..........#.#....#
....#..#......#..##.#...##.....
..#.#...#.####....#.#..#.#..#..
.........##......#.....##......
##.#.###.#.....#.....####.#..#.
.....#.....#..#....#..###.#....
##..#.#...#.##....#....#.......
.....#......#.#...##..#.#......
....##..#...#...##..##.#....#.#
............#..........##.#....
##..#..#.##..##..#.#....#.#.#..
.......#.#...#...#.#...#..#....
#....#.#...#...#........#..#...
...........#.......#...##..###.
.#..##......#.##.........##..#.
...#...#...###.#.##....##.#..#.
#...#..#.#.#.....##..#.......#.
.##..#.###.##......#.#....#.#.#
..#....#.......#..#..#.#.#.##..
#...#...###...###.........#....
.#.#...#.....##.#.#..#....#.##.
.........#.#.##.....#.#.###....
...#.#...#......#...####......#
...##..##....##......##...###..
###...#..#.......##.....#....#.
...#..#..#..###...##.##..#..#..
...#......#......##..#.#.##..#.
...#.........#....#.#....#.#...
##................#..#.#.....#.
....#.##...#..#.##...##.#.....#
......#..##.##..###.#..#.##.##.
.#.#...###.....###.....##...###
.##.....#.#.#..#..###..#..#..#.
#.......#..#..#....##.....#....
...#.#.##..#..#......##.##...#.
....##.#......#...#..#..#......
.####.#..#.....#..##.#...##..##
..#..#...#..........###..#....#
.#.#.##.##...#............#....
........##..##......#.##..#.###
...#.#....###......##.......#..
..##...#...#.#..#.....#.....#..
##..#...###..#..#.#.#...#...#..
.....#..#....##.....##.....###.
....##...###.#..#.#....##..#..#
#......#...#....#......#...##..
....#.##...#.#......#.#.##...#.
.......#.....#...#####...#.#...
...#.....##.#............#.....
...#.#........#.#.#..#.........
....###......#.#.#..#.####.#..#
#.....#.#.#.....#.#.#.....#..#.
..##.##......#...#.#...........
###..###....#.#####......###...
..##..............##.#.#....#.#
#..#...#..........#..#.#.#..###
##.###............#....#.#...#.
#.#..#.#..##.#.#....#...#......
#....#...#..##.....#..#.#..###.
..#.....#.#....#.#..#.##.#..##.
...##...#.#.##...#....###....#.
......###.####.......#..#.#.#.#
.#..............##........#....
...##.##...##....#..#.......#..
.....#.....#....###...#..#..#.#
.#.....#..#.....#......#.....##
#.#.##.#..#..#.....#.##..###...
..#......#...##.###..#.#...#..#
......#.....#...##......#......
##.#........#..........#.....#.
#........##.#............##....
...#......##...#.#.....##......
...##.......#....#.#..#.#.###..
..#....##..##.##.....###....#..
..#...#.#...#.....#..........#.
......#...#...#.#.##.#...#.#.#.
.#...#......#.##........#......
.##.##..#....#...#.#...##......
#..#......#.#...........#....#.
....##.#....#...#..#....#.#..##
#....##.##....#.#..##.#........
.##.##.#....##.....#..#....#..#
...#...#.....###.#.##..........
....#...#....##.......###......
#.........#......#.#.......#...
#..........#..##..#.#..........
.....#.......#..##.##....##...#
........................#.#....
#..#.........#.............#..#
#..#.....#.......#....#....#.#.
..##..##.......##....#...#.....
.##......#..##......#.###......
...#.#........#.......##..###..
..##...###.###......#...#....##
#...#...#.....###.#.#.#..#.....
#....#.........#..##...#...##..
#..###..#.#.#.##.#..#.#....#.##
#...#.#.....#.###.#.......#....
..##..#..#....#.#...........#.#
#.........#.#......#...##......
.######......#..#....#.#.#....#
##..#.#..####.###.........#....
###########.....##.##...#..#...
#...##.#.#....#.#....#......#..
...#..##..#..##..#......#....#.
.#....#...#....#.#..##....##...
#..#.#............#....#.#...#.
...#...#..#.#.##......#..#.#...
#.#...##.....#..#.##......####.
.#.#..##..#.....#.#..#.##......
#.#.##......##.....#..#.#..#...
#..##...#.##.#.......#.##......
..#.......#.#.#...##..##...#...
.#...#..#..#.#.........#..##...
#..#.......#....#.#...#.###...#
.......#..#.......##.#.#...#.#.
.#.................###.#..###..
..........#.#.....##..#####...#
#......#.#..##.#.#...#.##.#....
#......#.#..##.##.#...#....#...
....#..#......#....#....#######
.#...#......#....###......#.###
#.#....#.#...#.###......#..#..#
.###......#.#...#.####.#..####.
######.#.....###.#...#.#.....#.
.#.###....#..#.#.....#.....####
.......###.#.........#..#......
#...#.....##.#......####.......
..#.#..##.#.#...#...#..##..##..
.....#...##.....#...##......##.
##..#..#.##..#.#......#.....#..
##.........#.#.##.#..#.#....#.#
.#........###...#.........#....
...#..#.#..#....####...........
#.#....#..##..####.#...#.##....
.#.....#.......#..........#..##
...#.......#...###..#.....#..##
.........#.###.#..##...#.##...#
.#..........##..####...#..#.#.#
.#...##...#............##...#.#
...#....#.#..........#.#..#.#..
.#.#...##....##.#.#.#....#.....
....#..#.....#.#..#.#..#.##.###
.....#.#.....#..#......#.#.#...
.....#.#.#..###..#.#..###...#..
#.......####...#.#..#......##.#
....#..#..###......###.##....#.
##.....#.....#.............#..#
#..#..#...##.....##..#..#.#....
.....#.#.###...#...............
#.#.#.....#.#..#.#...#.......#.
..##.##............#....#..##..
#....##...#.....#.###...#.#....
#...##.#.........#...#....#....
##.##.#...#.#...###..#....##..#
....#....##..#..#.......#...##.
.#...#...#..#.....#..###.#..#.#
....#..###......#....##....#...
#.#.....#....##.#..#.#...###...
.......#............#......#...
.##..#.###.#.............###...
..##...##.#.#.#.....#........##
....#.###....#..#..#...#...#..#
.....#...#...#..#....#.....##..
###.#.#.....#......####.....#..
#.#.###............#......#....
..#.....#..#..#..#....#......#.
#...######...#....#.##...##.#.#
##.#.#.#..##......##.#..#.#...#
............#.#..#.##....#.....
......#............#.#...#..#.#
.#..##...##..#.#.#..###.....##.
#.###.#...........#...#....#...
....##.....#...##...#...###.#.#
.####.#.#.....#.#..#.#.##......
.#...##......###...#..##..#.#..
.#......#...#....##.....##..#..
..........##.....###.##.#...#.#
.#........##.#..............#..
#...###..#...#.....#....#.....#
...#......#..#...#...#..###.#..
.#...##..#........#.......#.#..
.#.#.##.........##.##......#..#
#...#.#.#...#.....#.#...#.#..#.
#.#..#...#...#...##..........#.
.#...........#....#..#.#..#.#..
#.......#......#..#...#........
.....#..#...##..###..##........
......#...#.....#..#.#.#....##.
....##..##..##....###.##.......
.#........##.#.#...#..#........
.....##...##...#......#..#...#.
..#.....#....###.#..##....#..#.
......#..#...####.#.....##.####)_";
} // namespace Day3
